#pragma once

// Control flags
#define HTC_ISAUTOSCROLL	0x0000001
#define HTC_ISWORDWRAP		0x0000002
#define HTC_ISLIMITED		0x0000004
#define HTC_ISDEFAULTLINKS	0x0000008
#define HTC_ISARROWCURSOR	0x0000010
#define HTC_ISHANDCURSOR	0x0000020

// Text style flags
#define HTC_BOLD			0x0000001
#define HTC_ITALIC			0x0000002
#define HTC_LINK			0x0000004
#define HTC_STRIKEOUT		0x0000008
#define HTC_UNDERLINE		0x0000010

static const struct
{
	LPCTSTR		pszScheme;
	unsigned	uiLen;
} _apszSchemes[] =
{
	{ _T("ed2k://"), sizeof(_T("ed2k://")) / sizeof(TCHAR) - 1 },
	{ _T("ftp."), sizeof(_T("ftp.")) / sizeof(TCHAR) - 1 },
	{ _T("ftp://"), sizeof(_T("ftp://")) / sizeof(TCHAR) - 1 },
	{ _T("http://"), sizeof(_T("http://")) / sizeof(TCHAR) - 1 },
	{ _T("https://"), sizeof(_T("https://")) / sizeof(TCHAR) - 1 },
	{ _T("mailto:"), sizeof(_T("mailto:")) / sizeof(TCHAR) - 1 },
	{ _T("www."), sizeof(_T("www.")) / sizeof(TCHAR) - 1 },
	{ _T("www1."), sizeof(_T("www1.")) / sizeof(TCHAR) - 1 },
	{ _T("www2."), sizeof(_T("www2.")) / sizeof(TCHAR) - 1 },
	{ _T("www3."), sizeof(_T("www3.")) / sizeof(TCHAR) - 1 },
	{ _T("www4."), sizeof(_T("www4.")) / sizeof(TCHAR) - 1 },
	{ _T("www5."), sizeof(_T("www5.")) / sizeof(TCHAR) - 1 }
};

class CHTRichEditCtrl : public CRichEditCtrl
{
	DECLARE_DYNAMIC(CHTRichEditCtrl)

public:
	CHTRichEditCtrl();
	virtual ~CHTRichEditCtrl();

	void SetTitle(LPCTSTR pszTitle);
	void Reset();

	void AppendText(LPCTSTR pszMsg, COLORREF crTextColor = CLR_DEFAULT, COLORREF crBackColor = CLR_DEFAULT, DWORD dwFlags = 0);

	CString GetHtml();
	CString GetToolTip();

	void SetFont(CFont* pFont, bool bRedraw = true);
	void ScrollToLastLine();

	DWORD				m_dwFlags;
	COLORREF			m_crDefaultForeground;
	COLORREF			m_crDefaultBackground;
	CString				m_strURL;

protected:
	CString				m_strTitle;
	long				m_lMaxBufSize;
	HCURSOR				m_hArrowCursor;
	HCURSOR				m_hHandCursor;

	void SaveLogToDisk();
	void SaveRtfToDisk();

	DECLARE_MESSAGE_MAP()
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg BOOL OnEnLink(NMHDR *pNMHDR, LRESULT *pResult);

private:
	static DWORD __stdcall MEditStreamOutCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
	{
		CString		strThisWrite;

		strThisWrite.GetBufferSetLength(cb);

		CString		*pstrBuffer = (CString *)dwCookie;

		for (int i = 0; i < cb; i++)
		{
			strThisWrite.SetAt(i, *(pbBuff + i));
		}

		*pstrBuffer += strThisWrite;

		*pcb = strThisWrite.GetLength();
		strThisWrite.ReleaseBuffer();
		return 0;
	}
};
