#pragma once

#include "preferences.h"
#include "afxwin.h"
#include "FontPreviewCombo.h"

// CPPgWindow dialog

class CPPgWindow : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgWindow)

public:
	CPPgWindow();
	virtual ~CPPgWindow();
	void SetPrefs(CPreferences* in_prefs) {	m_pPrefs = in_prefs; }

// Dialog Data
	enum { IDD = IDD_PPG_WINDOW };
protected:
	CPreferences *m_pPrefs;

	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}
	virtual void DoDataExchange(CDataExchange* pDX);
	void LoadSettings(void);
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	void Localize(void);
	virtual BOOL OnApply();
	afx_msg void OnSettingsChange()						{ SetModified(); }
protected:
	BOOL startMin;
	BOOL minTray;
	BOOL closeToTray;
	BOOL bPromptOnExit;
	BOOL bPromptOnDisconnect;
	BOOL bPromptOnFriendDel;
	BOOL bringToForeground;
	BOOL showRateOnTitle;
	BOOL showSpeedMeterOnToolbar;
private:
	CFontPreviewCombo	fontPreviewCombo;
	CComboBox			fontSizeCombo;
	CButton startMinCheck;
	CButton minTrayCheck;
	CButton closeToTrayCheck;
	CButton promptOnExitCheck;
	CButton promptOnDisconnectCheck;
	CButton promptOnFriendDelCheck;
	CButton bringToForegroundCheck;
	CButton showRateOnTitleCheck;
	CButton showSpeedMeterOnToolbarCheck;
	CString usedFontDesc;
};
